puzzle_input = [ ...
    '.#..#'; ...
    '.....'; ...
    '#####'; ...
    '....#'; ...
    '...##'];

puzzle_input = [ ...
    '.#....#####...#..'; ...
    '##...##.#####..##'; ...
    '##...#...#.#####.'; ...
    '..#.....#...###..'; ...
    '..#.#.....#....##'];

puzzle_input = [ ...
    '.#..##.###...#######'; ...
    '##.############..##.'; ...
    '.#.######.########.#'; ...
    '.###.#######.####.#.'; ...
    '#####.##.#.##.###.##'; ...
    '..#####..#.#########'; ...
    '####################'; ...
    '#.####....###.#.#.##'; ...
    '##.#################'; ...
    '#####.##.###..####..'; ...
    '..######..##.#######'; ...
    '####.##.####...##..#'; ...
    '.#####..#.######.###'; ...
    '##...#.##########...'; ...
    '#.##########.#######'; ...
    '.####.#.###.###.#.##'; ...
    '....##.##.###..#####'; ...
    '.#.#.###########.###'; ...
    '#.#.#.#####.####.###'; ...
    '###.##.####.##.#..##'];

puzzle_input = [ ...
    '#.#....#.#......#.....#......####.'; ...
    '#....#....##...#..#..##....#.##..#'; ...
    '#.#..#....#..#....##...###......##'; ...
    '...........##..##..##.####.#......'; ...
    '...##..##....##.#.....#.##....#..#'; ...
    '..##.....#..#.......#.#.........##'; ...
    '...###..##.###.#..................'; ...
    '.##...###.#.#.......#.#...##..#.#.'; ...
    '...#...##....#....##.#.....#...#.#'; ...
    '..##........#.#...#..#...##...##..'; ...
    '..#.##.......#..#......#.....##..#'; ...
    '....###..#..#...###...#.###...#.##'; ...
    '..#........#....#.....##.....#.#.#'; ...
    '...#....#.....#..#...###........#.'; ...
    '.##...#........#.#...#...##.......'; ...
    '.#....#.#.#.#.....#...........#...'; ...
    '.......###.##...#..#.#....#..##..#'; ...
    '#..#..###.#.......##....##.#..#...'; ...
    '..##...#.#.#........##..#..#.#..#.'; ...
    '.#.##..#.......#.#.#.........##.##'; ...
    '...#.#.....#.#....###.#.........#.'; ...
    '.#..#.##...#......#......#..##....'; ...
    '.##....#.#......##...#....#.##..#.'; ...
    '#..#..#..#...........#......##...#'; ...
    '#....##...#......#.###.#..#.#...#.'; ...
    '#......#.#.#.#....###..##.##...##.'; ...
    '......#.......#.#.#.#...#...##....'; ...
    '....##..#.....#.......#....#...#..'; ...
    '.#........#....#...#.#..#....#....'; ...
    '.#.##.##..##.#.#####..........##..'; ...
    '..####...##.#.....##.............#'; ...
    '....##......#.#..#....###....##...'; ...
    '......#..#.#####.#................'; ...
    '.#....#.#..#.###....##.......##.#.'];


%Compute the number of asteroids that can be detected from each asteroid
numAsteroids = zeros(size(puzzle_input));
for x = 1 : size(puzzle_input,2)
    for y = 1 : size(puzzle_input,1)
        if puzzle_input(y,x) == '#'
            numAsteroids(y,x) = d10_numAsteroids(puzzle_input, x, y);
        end
    end
end
%Get the location of the monitoring station
[yMon, xMon] = ind2sub(size(puzzle_input), find(numAsteroids == max(numAsteroids(:))));

%ANSWER TO QUESTION #1: number of asteroids that can be detected from the
%monitoring station
disp(['Number of asteroids = ', num2str(numAsteroids(yMon,xMon))]);

%Compute the vaporization index for each asteroid
[~, vaporizationIndex] = d10_vaporize(puzzle_input, xMon, yMon);
%Get the location of the 200th asteroid to be vaporized
[y200, x200] = ind2sub(size(puzzle_input), find(v == 200));

%ANSWER TO QUESTION #2: X*100+Y where [X,Y] are the coordinates of the
%200th asteroid to be vaporized
numOnesTimesNumTwos = nnz(layers(:,:,idxFewestZeros) == 1) * nnz(layers(:,:,idxFewestZeros) == 2);
disp(['X*100+Y for the 200th asteroid = ', num2str((x200-1) * 100 + (y200-1))]);
